#include <ilsolver/ilosolver.h>

ILOSTLBEGIN

int main() {

  try {

    IloEnv env;
    IloModel model(env);

    IloNumVar a(env,1,26,ILOINT), b(env,1,26,ILOINT), c(env,1,26,ILOINT), d(env,1,26,ILOINT);
    IloNumVar e(env,1,26,ILOINT), f(env,1,26,ILOINT), g(env,1,26,ILOINT), h(env,1,26,ILOINT);
    IloNumVar i(env,1,26,ILOINT), j(env,1,26,ILOINT), k(env,1,26,ILOINT), l(env,1,26,ILOINT);
    IloNumVar m(env,1,26,ILOINT), n(env,1,26,ILOINT), o(env,1,26,ILOINT), p(env,1,26,ILOINT);
    IloNumVar q(env,1,26,ILOINT), r(env,1,26,ILOINT), s(env,1,26,ILOINT), t(env,1,26,ILOINT);
    IloNumVar u(env,1,26,ILOINT), v(env,1,26,ILOINT), w(env,1,26,ILOINT), x(env,1,26,ILOINT);
    IloNumVar y(env,1,26,ILOINT), z(env,1,26,ILOINT);

    IloNumVarArray solution(env,26,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z);

    model.add(b+a+l+l+e+t==45);
    model.add(c+e+l+l+o==43);
    model.add(c+o+n+c+e+r+t==74);
    model.add(f+l+u+t+e==30);
    model.add(f+u+g+u+e==50);
    model.add(g+l+e+e==66);
    model.add(j+a+z+z==58);
    model.add(l+y+r+e==47);
    model.add(o+b+o+e==53);
    model.add(o+p+e+r+a==65);
    model.add(p+o+l+k+a==59);
    model.add(q+u+a+r+t+e+t==50);
    model.add(s+a+x+o+p+h+o+n+e==134);
    model.add(s+c+a+l+e==51);
    model.add(s+o+l+o==37);
    model.add(s+o+n+g==61);
    model.add(s+o+p+r+a+n+o==82);
    model.add(t+h+e+m+e==72);
    model.add(v+i+o+l+i+n==100);
    model.add(w+a+l+t+z==34);

    model.add(IloAllDiff(env,solution));

    IloGoal goal = IloGenerate(env,solution,IlcChooseFirstUnboundInt);

    IloSolver solver(model);

    IlcSearch search = solver.newSearch(goal);

    while (search.next()) {
      solver.out() << solver.getIntVarArray(solution) << endl;
    }

    search.end();
    env.end();

    return 0;

  } catch (IloException& ex) {

    cerr << "Error: " << ex << endl;

  }

}
