#include <ilsolver/ilosolver.h>

ILOSTLBEGIN

int main() {

  try {

    IloEnv env;
    IloModel model(env);

    // -------------------------------------------------------------------------
    // This is the translation of the search script
    // -------------------------------------------------------------------------

    IloNumVar s(env,0,9,ILOINT),e(env,0,9,ILOINT),n(env,0,9,ILOINT),d(env,0,9,ILOINT);
    IloNumVar m(env,0,9,ILOINT),o(env,0,9,ILOINT),r(env,0,9,ILOINT),y(env,0,9,ILOINT);

    IloNumVarArray solution(env,8,s,e,n,d,m,o,r,y);

    model.add(s != 0);
    model.add(m != 0);
    model.add(IloAllDiff(env,solution));
    model.add(1000*s+100*e+10*n+d+1000*m+100*o+10*r+e == 10000*m+1000*o+100*n+10*e+y);

    // distribution
    IloGoal goal = IloGenerate(env,solution,IlcChooseMinSizeInt);

    // -------------------------------------------------------------------------

    IloSolver solver(model);

    IlcSearch search = solver.newSearch(goal);

    while (search.next()) {
      solver.out() << solver.getIntVarArray(solution) << endl;
    }

    search.end();
    env.end();

    return 0;

  } catch (IloException& ex) {

    cerr << "Error: " << ex << endl;

  }

}
